<template>
  <div>
    <div v-if="!isLoading">
      <div class="layout__col-2-2 dashboard-app__layout">
        <div
          class="dashboard-app__layout-scrollable"
          :style="{ width: `calc(100% - ${sidebarWidth}px)` }"
        >
          <div class="dashboard-app__content">
            <DashboardContentHeader :dashboard="dashboard" />
            <EmptyDashboard
              v-if="isEmpty"
              :dashboard="dashboard"
              @widget-type-selected="createWidget($event)"
            />
            <template v-else>
              <WidgetBoard :dashboard="dashboard" />
              <CreateWidgetButton
                v-if="isEditMode && canCreateWidget"
                :dashboard="dashboard"
                @widget-type-selected="createWidget($event)"
              />
            </template>
          </div>
        </div>
        <DashboardSidebar
          v-if="isEditMode"
          :dashboard="dashboard"
          :style="{ width: `${sidebarWidth}px` }"
        />
      </div>
    </div>
  </div>
</template>

<script>
import EmptyDashboard from '@baserow/modules/dashboard/components/EmptyDashboard'
import CreateWidgetButton from '@baserow/modules/dashboard/components/CreateWidgetButton'
import DashboardSidebar from '@baserow/modules/dashboard/components/DashboardSidebar'
import DashboardContentHeader from '@baserow/modules/dashboard/components/DashboardContentHeader'
import WidgetBoard from '@baserow/modules/dashboard/components/WidgetBoard'
import { mapGetters, mapActions } from 'vuex'
import { notifyIf } from '@baserow/modules/core/utils/error'

export default {
  name: 'DashboardContent',
  components: {
    EmptyDashboard,
    CreateWidgetButton,
    WidgetBoard,
    DashboardContentHeader,
    DashboardSidebar,
  },
  props: {
    dashboard: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      contentHeight: 0,
    }
  },
  computed: {
    ...mapGetters({
      isEditMode: 'dashboardApplication/isEditMode',
      isEmpty: 'dashboardApplication/isEmpty',
      isLoading: 'dashboardApplication/isLoading',
    }),
    sidebarWidth() {
      if (this.isEditMode) {
        return 352
      }
      return 0
    },
  },
  methods: {
    ...mapActions({
      toggleEditMode: 'dashboardApplication/toggleEditMode',
      enterEditMode: 'dashboardApplication/enterEditMode',
    }),
    canCreateWidget() {
      return this.$hasPermission(
        'dashboard.create_widget',
        this.dashboard,
        this.dashboard.workspace.id
      )
    },
    async createWidget(widgetType) {
      const typeFromRegistry = this.$registry.get('dashboardWidget', widgetType)
      try {
        await this.$store.dispatch('dashboardApplication/createWidget', {
          dashboard: this.dashboard,
          widget: { title: typeFromRegistry.name, type: widgetType },
        })
        this.enterEditMode()
      } catch (error) {
        notifyIf(error, 'dashboard')
      }
    },
  },
}
</script>
